/****************************************Copyright (c)**************************************************                         
**
**                                 http://www.powermcu.com
**
**--------------File Info-------------------------------------------------------------------------------
** File name:			GLCD.h
** Descriptions:		TFT (IO)
**
**------------------------------------------------------------------------------------------------------
** Created by:			AVRman
** Created date:		2011-1-26
** Version:				1.0
** Descriptions:		The original version
**
**------------------------------------------------------------------------------------------------------
** Modified by:			
** Modified date:	
** Version:
** Descriptions:		
********************************************************************************************************/

//po lcd ili933x
#define lcd_modus 1// 0=>spi 1=>8bit 2=>16bit

//#define cs_lcd_port 		2
//#define cs_lcd_pin  		10
//#define lcd_ssp 2 //  0=>ssp0_1 1=>ssp0_2 2=>ssp1

#if lcd_modus == 0

/*SSP channel to use (
0:SSP0_1-0.15,
1:SSP0_2-1.20,
2:SSP1  -0.07
3:swspi)*/
#define lcd_ssp	0	//
#define lcd_swspi	0	//

#if lcd_ssp	==0
#define cs_sd_port 		0
#define cs_sd_pin  		16
#define sck_sd_port  		0
#define sck_sd_pin  		15
#define miso_sd_port 		0
#define miso_sd_pin 		17
#define mosi_sd_port 		0
#define mosi_sd_pin 		18
#endif
#endif


//config 8bit
#if lcd_modus == 1
#define lcd_port_cs 2
#define lcd_pin_cs  8
#define lcd_port_rs 0
#define lcd_pin_rs  17
#define lcd_port_wr 0
#define lcd_pin_wr  18
#define lcd_port_rd 1
#define lcd_pin_rd  29
#define lcd_port_data 2			//pin db8
#define lcd_pin_data_shift  0 	//pin db8
#endif


#ifndef __GLCD_H 
#define __GLCD_H

/* Includes ------------------------------------------------------------------*/
//#include "lpc17xx_gpio.h"
//#include "lpc17xx_pinsel.h"
//#include "lpc17xx.h"

/* Private define ------------------------------------------------------------*/

#define LCD_CS(x)   ((x) ?  \
(pinSET(lcd_port_cs,lcd_pin_cs)) : \
(pinCLR(lcd_port_cs,lcd_pin_cs)));
#define LCD_WR(x)   ((x) ?  \
(pinSET(lcd_port_wr,lcd_pin_wr)) : \
(pinCLR(lcd_port_wr,lcd_pin_wr)));
#define LCD_RS(x)   ((x) ?  \
(pinSET(lcd_port_rs,lcd_pin_rs)) : \
(pinCLR(lcd_port_rs,lcd_pin_rs)));
#define LCD_RD(x)   ((x) ?  \
(pinSET(lcd_port_rd,lcd_pin_rd)) : \
(pinCLR(lcd_port_rd,lcd_pin_rd)));



/* LCD Interface
//#define PIN_CS      (1 << 15)
//#define PIN_CS      (1 << 8)//2.8
#define PIN_RS		(1 << 17)
#define PIN_WR		(1 << 18)
#define PIN_RD		(1 << 16)
*/
//#define LCD_CS(x)   ((x) ? GPIO_SetValue(2, PIN_CS ) : GPIO_ClearValue(2, PIN_CS ) );
//#define LCD_CS(x)   ((x) ? (LPC_GPIO2->FIOSET = PIN_CS) : (LPC_GPIO2->FIOCLR = PIN_CS));

//#define LCD_RS(x)   ((x) ? GPIO_SetValue(1, PIN_RS ) : GPIO_ClearValue(1, PIN_RS ) );
//#define LCD_RS(x)   ((x) ? (LPC_GPIO0->FIOSET = PIN_RS) : (LPC_GPIO0->FIOCLR = PIN_RS));

//#define LCD_WR(x)   ((x) ? GPIO_SetValue(1, PIN_WR ) : GPIO_ClearValue(1, PIN_WR ) );
//#define LCD_WR(x)   ((x) ? (LPC_GPIO0->FIOSET = PIN_WR) : (LPC_GPIO0->FIOCLR = PIN_WR));

//#define LCD_RD(x)   ((x) ? GPIO_SetValue(1, PIN_RD ) : GPIO_ClearValue(1, PIN_RD ) );
//#define LCD_RD(x)   ((x) ? (LPC_GPIO0->FIOSET = PIN_RD) : (LPC_GPIO0->FIOCLR = PIN_RD));


/* Private define ------------------------------------------------------------*/
#define DISP_ORIENTATION  0 //0x90° screen rotation
//#define DISP_ORIENTATION  1 //1x90° screen rotation
//#define DISP_ORIENTATION  2 //2x180° screen rotation
//#define DISP_ORIENTATION  3 //3x270° screen rotation

#if  ( DISP_ORIENTATION == 1 ) || ( DISP_ORIENTATION == 3 )
//querformat
#define  MAX_X  320
#define  MAX_Y  240   
#elif  ( DISP_ORIENTATION == 0 ) || ( DISP_ORIENTATION == 2 )
//hochformat
#define  MAX_X  240
#define  MAX_Y  320   
#endif

/* LCD color */
#define White          0xFFFF
#define Black          0x0000
#define Grey           0xF7DE
#define Blue           0x001F
#define Blue2          0x051F
#define Red            0xF800
#define Magenta        0xF81F
#define Green          0x07E0
#define Cyan           0x7FFF
#define Yellow         0xFFE0

#define Navy            0x000F      /*   0,   0, 128 */
#define DarkGreen       0x03E0      /*   0, 128,   0 */
#define DarkCyan        0x03EF      /*   0, 128, 128 */
#define Maroon          0x7800      /* 128,   0,   0 */
#define Purple          0x780F      /* 128,   0, 128 */
#define Olive           0x7BE0      /* 128, 128,   0 */
#define LightGrey       0xC618      /* 192, 192, 192 */
#define DarkGrey        0x7BEF      /* 128, 128, 128 */
#define Transparent     0x0001	    //No Color Back Ground


/******************************************************************************
* Function Name  : RGB565CONVERT
* Description    : 24λת��16λ
* Input          : - red: R
*                  - green: G 
*				   - blue: B
* Output         : None
* Return         : RGB ��ɫֵ
* Attention		 : None
*******************************************************************************/




#define RGB565CONVERT(red, green, blue)\
(uint16_t)( (( red   >> 3 ) << 11 ) | \
(( green >> 2 ) << 5  ) | \
( blue  >> 3 ))

/* Private function prototypes -----------------------------------------------*/
void LCD_Initializtion(void);
void LCD_Clear(uint16_t Color);
uint16_t LCD_GetPoint(uint16_t Xpos,uint16_t Ypos);
void LCD_SetPoint(uint16_t Xpos,uint16_t Ypos,uint16_t point);
void LCD_DrawLine( uint16_t x0, uint16_t y0, uint16_t x1, uint16_t y1 , uint16_t color );
void PutChar( uint16_t Xpos, uint16_t Ypos, uint8_t ASCI, uint16_t charColor, uint16_t bkColor );
void GUI_Text(uint16_t Xpos, uint16_t Ypos, uint8_t *str,uint16_t Color, uint16_t bkColor);
void LCD_regionSTRING(
		uint16_t startx, uint16_t starty, char *str,
		 uint16_t Color1, uint16_t Color2,uint8_t rand,uint8_t multiPixelx);
void lcd_goto(char Zeile,char Spalte);


#include "lib_fonts.h"
#include "xglcd.h"
#include "kklcdxx.h"

#endif 

/*********************************************************************************************************
      END FILE
*********************************************************************************************************/
