/****************************************Copyright (c)**************************************************                         
**
**                                 http://www.powermcu.com
**
**--------------File Info-------------------------------------------------------------------------------
** File name:			GLCD.h
** Descriptions:		TFT (IO)
**
**------------------------------------------------------------------------------------------------------
** Created by:			AVRman
** Created date:		2011-1-26
** Version:				1.0
** Descriptions:		The original version
**
**------------------------------------------------------------------------------------------------------
** Modified by:			
** Modified date:	
** Version:
** Descriptions:		
********************************************************************************************************/
/*#define pinSET(portn,pinn)    (*(volatile uint32_t*)(0x2009C018UL+(portn*0x20UL)))|=(1UL<<pinn)
#define pinCLR(portn,pinn)    (*(volatile uint32_t*)(0x2009C01CUL+(portn*0x20UL)))|=(1UL<<pinn)
#define pinDIRin(portn,pinn)  (*(volatile uint32_t*)(0x2009C000UL+(portn*0x20UL)))&=~(1UL<<pinn)
#define pinDIRout(portn,pinn) (*(volatile uint32_t*)(0x2009C000UL+(portn*0x20UL)))|=(1UL<<pinn)
*/
/* Includes ------------------------------------------------------------------*/
/*
#include "GLCD.h"
#include "AsciiLib.h"
#include "lib_fonts.h"
*/

/* Private variables ---------------------------------------------------------*/
static uint8_t LCD_Code;

/* Private define ------------------------------------------------------------*/
#define  ILI9320    0  /* 0x9320 */
#define  ILI9325    1  /* 0x9325 */
#define  ST7781     3  /* 0x7783 */
#define  LGDP4531   4  /* 0x4531 */
#define  SPFD5408B  5  /* 0x5408 */
#define  R61505U    6  /* 0x1505 0x0505 */
#define  HX8347A    7  /* 0x0047 */
#define  LGDP4535   8  /* 0x4535 */
//==================================================
 void LCD_Configuration(void)
{
	/* Configure the LCD Control pins */
	 uint8_t ix=0,pin2[]={0,1,2,3,4,5,6,7};
	 for	(ix=0;ix<8;ix++){
	 	LPC_GPIO2->FIODIR|=(1<<pin2[ix]);
	 	LPC_GPIO2->FIOSET|=(1<<pin2[ix]);
	 }

	 uint8_t  pin0[]={15,16,17,18};
	 for	(ix=0;ix<4;ix++){
	 	LPC_GPIO0->FIODIR|=(1<<pin0[ix]);
	 	LPC_GPIO0->FIOSET|=(1<<pin0[ix]);
	 }
//	 	LPC_GPIO2->FIODIR|=(1<<8);
//	 	LPC_GPIO2->FIOSET|=(1<<8);
	 	pinDIRout(lcd_port_cs,lcd_pin_cs);
	 	pinSET(lcd_port_cs,lcd_pin_cs);

}

 //==================================================
 void LCD_Send (uint16_t byte)
{
	uint32_t temp;

#ifdef xx16bit
	nn
	temp = byte;
	LPC_GPIO2->FIOPIN =  temp & 0x000000ff;        /* Write D0..D7 */
	LPC_GPIO0->FIOPIN =  (temp << 7) & 0x007F8000; /* Write D8..D15 */
#endif

	//Lcdd = Temph
	temp=(byte>>8);
	LPC_GPIO2->FIOCLR|=0xff;
	LPC_GPIO2->FIOSET|=temp;

 	// ((temp&128)>>7)+((temp&64)>>5)+((temp&32)>>3)+((temp&16)>>1)+
	// ((temp&8)<<1)+((temp&4)<<3)+((temp&2)<<5)+((temp&1)<<7);
	LCD_WR(0);
	LCD_WR(1);
	//  Lcdd = Templ
//	temp=(byte & 0xff);
//	temp=((byte&128)>>7)+((byte&64)>>5)+((byte&32)>>3)+((byte&16)>>1)+((byte&8)<<1)+((byte&4)<<3)+((byte&2)<<5)+((byte&1)<<7);
/*	temp=((byte&128)>>7);
	temp+=((byte&64)>>5);
	temp+=((byte&32)>>3);
	temp+=((byte&16)>>1);
	temp+=((byte&8)<<1);
	temp+=((byte&4)<<3);
	temp+=((byte&2)<<5);
	temp+=((byte&1)<<7);
*/
	LPC_GPIO2->FIOCLR|=0xff;
	LPC_GPIO2->FIOSET|=byte & 0xff;
}

 //==================================================
void LCD_WriteIndex(uint16_t index)
{
	LCD_CS(0);
	LCD_RS(0);
	LCD_RD(1);
	LCD_Send( index ); 
	LCD_WR(0);  
	LCD_WR(1);
	LCD_CS(1);

}

//==================================================
void LCD_WriteData(uint16_t data)
{				
	LCD_CS(0);
	LCD_RS(1);   
	LCD_Send( data );
	LCD_WR(0);     
	LCD_WR(1);
	LCD_CS(1);
}

//==================================================
void LCD_WriteReg(uint16_t LCD_Reg,uint16_t LCD_RegValue)
{ 
	/* Write 16-bit Index, then Write Reg */  
	LCD_WriteIndex(LCD_Reg);         
	/* Write 16-bit Reg */
	LCD_WriteData(LCD_RegValue);  
}
//==================================================
//static __attribute__((always_inline))
void LCD_SetCursor(uint16_t Xpos,uint16_t Ypos){
			uint16_t i=Xpos;
#if ( DISP_ORIENTATION == 0 )//0° grad
			Xpos=MAX_X-Xpos;
			Ypos=MAX_Y-Ypos;
#endif
#if ( DISP_ORIENTATION == 1 )//0° grad
			Xpos=MAX_Y-Ypos;
			Ypos=i;
#endif
#if ( DISP_ORIENTATION == 2 )//0° grad
			//Xpos=Xpos;
			//Ypos=MAX_Y-Ypos;
#endif
#if ( DISP_ORIENTATION == 3 )//0° grad
			Xpos=Ypos;
			Ypos=MAX_X-i;
#endif


    	LCD_WriteReg(0x0020, Xpos );
        LCD_WriteReg(0x0021, Ypos );
}
//==================================================
static void delay_ms(uint16_t ms)    
{ 
	uint16_t i,j; 
	for( i = 0; i < ms; i++ )
	{ 
		for( j = 0; j < 1141; j++ );
	}
} 
//==================================================
void LCD_Initializtion(void)
{
	uint16_t DeviceCode=0x9325;
	
	LCD_Configuration();
	delay_ms(100);
//	DeviceCode = LCD_ReadReg(0x0000);		/* ��ȡ��ID	*/
	/* ��ͬ����IC ��ʼ����ͬ */
#if 1
	if( DeviceCode == 0x9325 || DeviceCode == 0x9328 )	
	{
		LCD_Code = ILI9325;
		LCD_WriteReg(0x00e7,0x0010);      
		LCD_WriteReg(0x0000,0x0001);  	/* start internal osc */
		LCD_WriteReg(0x0001,0x0100);     
		LCD_WriteReg(0x0002,0x0700); 	/* power on sequence */
		//Portrait//landscape

#if ( DISP_ORIENTATION == 0 )//0° grad
		LCD_WriteReg(0x0003,(1<<12) ); 	/* importance */
#endif
#if ( DISP_ORIENTATION == 1 )//90°
		LCD_WriteReg(0x0003,(1<<12)|(1<<5)|(1<<3) ); 	/* importance */
#endif
#if ( DISP_ORIENTATION == 2 )//180°
		LCD_WriteReg(0x0003,(1<<12)|(1<<4)|(1<<5) ); 	/* importance */
#endif
#if ( DISP_ORIENTATION == 3 )//270°
		LCD_WriteReg(0x0003,(1<<12)|(1<<4)|(1<<3) ); 	/* importance */
#endif


		LCD_WriteReg(0x0004,0x0000);                                   
		LCD_WriteReg(0x0008,0x0207);	           
		LCD_WriteReg(0x0009,0x0000);         
		LCD_WriteReg(0x000a,0x0000); 	/* display setting */        
		LCD_WriteReg(0x000c,0x0001);	/* display setting */        
		LCD_WriteReg(0x000d,0x0000); 			        
		LCD_WriteReg(0x000f,0x0000);
		/* Power On sequence */
		LCD_WriteReg(0x0010,0x0000);   
		LCD_WriteReg(0x0011,0x0007);
		LCD_WriteReg(0x0012,0x0000);                                                                 
		LCD_WriteReg(0x0013,0x0000);                 
		delay_ms(50);  /* delay 50 ms */		
		LCD_WriteReg(0x0010,0x1590);   
		LCD_WriteReg(0x0011,0x0227);
		delay_ms(50);  /* delay 50 ms */		
		LCD_WriteReg(0x0012,0x009c);                  
		delay_ms(50);  /* delay 50 ms */		
		LCD_WriteReg(0x0013,0x1900);   
		LCD_WriteReg(0x0029,0x0023);
		LCD_WriteReg(0x002b,0x000e);
		delay_ms(50);  /* delay 50 ms */		
		LCD_WriteReg(0x0020,0x0000);                                                            
		LCD_WriteReg(0x0021,0x0000);           
		delay_ms(50);  /* delay 50 ms */		
		LCD_WriteReg(0x0030,0x0007); 
		LCD_WriteReg(0x0031,0x0707);   
		LCD_WriteReg(0x0032,0x0006);
		LCD_WriteReg(0x0035,0x0704);
		LCD_WriteReg(0x0036,0x1f04); 
		LCD_WriteReg(0x0037,0x0004);
		LCD_WriteReg(0x0038,0x0000);        
		LCD_WriteReg(0x0039,0x0706);     
		LCD_WriteReg(0x003c,0x0701);
		LCD_WriteReg(0x003d,0x000f);
		delay_ms(50);  /* delay 50 ms */		
		LCD_WriteReg(0x0050,0x0000);        
		LCD_WriteReg(0x0051,0x00ef);   
		LCD_WriteReg(0x0052,0x0000);     
		LCD_WriteReg(0x0053,0x013f);
		LCD_WriteReg(0x0060,0xa700);        
		LCD_WriteReg(0x0061,0x0001); 
		LCD_WriteReg(0x006a,0x0000);
		LCD_WriteReg(0x0080,0x0000);
		LCD_WriteReg(0x0081,0x0000);
		LCD_WriteReg(0x0082,0x0000);
		LCD_WriteReg(0x0083,0x0000);
		LCD_WriteReg(0x0084,0x0000);
		LCD_WriteReg(0x0085,0x0000);
		  
		LCD_WriteReg(0x0090,0x0010);     
		LCD_WriteReg(0x0092,0x0000);  
		LCD_WriteReg(0x0093,0x0003);
		LCD_WriteReg(0x0095,0x0110);
		LCD_WriteReg(0x0097,0x0000);        
		LCD_WriteReg(0x0098,0x0000);  
		/* display on sequence */    
		LCD_WriteReg(0x0007,0x0133);
		
		LCD_WriteReg(0x0020,0x0000);  /* ����ַ0 */                                                          
		LCD_WriteReg(0x0021,0x0000);  /* ����ַ0 */     

	}
#else //if 1
#endif
delay_ms(50);   /* delay 50 ms */
}
//==================================================
void LCD_Clear(uint16_t Color){
	uint32_t index;
	LCD_SetCursor(0,0);
	LCD_WriteIndex(0x0022);
	for( index = 0; index < (MAX_X) * MAX_Y; index++ )	{
		LCD_WriteData(Color);
		//delay_ms(1);
	}
}
//==================================================
static uint16_t LCD_BGR2RGB(uint16_t color)
{
	uint16_t  r, g, b, rgb;
	
	b = ( color>>0 )  & 0x1f;
	g = ( color>>5 )  & 0x3f;
	r = ( color>>11 ) & 0x1f;
	
	rgb =  (b<<11) + (g<<5) + (r<<0);
	
	return( rgb );
}
//==================================================
void LCD_SetPoint(uint16_t Xpos,uint16_t Ypos,uint16_t point)
{
	if( Xpos >= MAX_X || Ypos >= MAX_Y )
	{
		return;
	}
	LCD_SetCursor(Xpos,Ypos);
	LCD_WriteReg(0x0022,point);
}

/******************************************************************************
* Function Name  : LCD_DrawLine
* Description    : Bresenham's line algorithm
* Input          : - x1: A�������
*                  - y1: A������� 
*				   - x2: B�������
*				   - y2: B������� 
*				   - color: ����ɫ
* Output         : None
* Return         : None
* Attention		 : None
*******************************************************************************/	 
void LCD_DrawLine( uint16_t x0, uint16_t y0, uint16_t x1, uint16_t y1 , uint16_t color )
{
    short dx,dy;      /* ����X Y�������ӵı���ֵ */
    short temp;       /* ��� �յ��С�Ƚ� �������ʱ���м���� */

    if( x0 > x1 )     /* X�����������յ� ������� */
    {
	    temp = x1;
		x1 = x0;
		x0 = temp;   
    }
    if( y0 > y1 )     /* Y�����������յ� ������� */
    {
		temp = y1;
		y1 = y0;
		y0 = temp;   
    }
  
	dx = x1-x0;       /* X�᷽���ϵ����� */
	dy = y1-y0;       /* Y�᷽���ϵ����� */

    if( dx == 0 )     /* X����û������ ����ֱ�� */ 
    {
        do
        { 
            LCD_SetPoint(x0, y0, color);   /* �����ʾ �费ֱ�� */
            y0++;
        }
        while( y1 >= y0 ); 
		return; 
    }
    if( dy == 0 )     /* Y����û������ ��ˮƽֱ�� */ 
    {
        do
        {
            LCD_SetPoint(x0, y0, color);   /* �����ʾ ��ˮƽ�� */
            x0++;
        }
        while( x1 >= x0 ); 
		return;
    }
	/* ����ɭ��ķ(Bresenham)�㷨���� */
    if( dx > dy )                         /* ����X�� */
    {
	    temp = 2 * dy - dx;               /* �����¸����λ�� */         
        while( x0 != x1 )
        {
	        LCD_SetPoint(x0,y0,color);    /* ����� */ 
	        x0++;                         /* X���ϼ�1 */
	        if( temp > 0 )                /* �ж����¸����λ�� */
	        {
	            y0++;                     /* Ϊ�������ڵ㣬����x0+1,y0+1�� */ 
	            temp += 2 * dy - 2 * dx; 
	 	    }
            else         
            {
			    temp += 2 * dy;           /* �ж����¸����λ�� */  
			}       
        }
        LCD_SetPoint(x0,y0,color);
    }  
    else
    {
	    temp = 2 * dx - dy;                      /* ����Y�� */       
        while( y0 != y1 )
        {
	 	    LCD_SetPoint(x0,y0,color);     
            y0++;                 
            if( temp > 0 )           
            {
                x0++;               
                temp+=2*dy-2*dx; 
            }
            else
			{
                temp += 2 * dy;
			}
        } 
        LCD_SetPoint(x0,y0,color);
	}
} 

/******************************************************************************
* Function Name  : PutChar
* Description    : ��Lcd��������λ����ʾһ���ַ�
* Input          : - Xpos: ˮƽ��� 
*                  - Ypos: ��ֱ���  
*				   - ASCI: ��ʾ���ַ�
*				   - charColor: �ַ���ɫ   
*				   - bkColor: ������ɫ 
* Output         : None
* Return         : None
* Attention		 : None
*******************************************************************************/
void PutChar( uint16_t Xpos, uint16_t Ypos, uint8_t ASCI, uint16_t charColor, uint16_t bkColor )
{
	uint16_t i, j;
    uint8_t buffer[16], tmp_char;
    GetASCIICode(buffer,ASCI);  /* ȡ��ģ��� */
    for( i=0; i<16; i++ )
    {
        tmp_char = buffer[i];
        for( j=0; j<8; j++ )
        {
            if( (tmp_char >> 7 - j) & 0x01 == 0x01 )
            {
                LCD_SetPoint( Xpos + j, Ypos + i, charColor );  /* �ַ���ɫ */
            }
            else
            {
                LCD_SetPoint( Xpos + j, Ypos + i, bkColor );  /* ������ɫ */
            }
 //           delay_ms(500);
        }
    }
}

//==================================================
void GUI_Text(uint16_t Xpos, uint16_t Ypos, uint8_t *str,uint16_t Color, uint16_t bkColor)
{
    uint8_t TempChar;
    do
    {
        TempChar = *str++;  
        PutChar( Xpos, Ypos, TempChar, Color, bkColor );    
        if( Xpos < MAX_X - 8 ){
            Xpos += 8;
        } 
        else if ( Ypos < MAX_Y - 16 )
        {
            Xpos = 0;
            Ypos += 16;
        }   
        else
        {
            Xpos = 0;
            Ypos = 0;
        }    
    }
    while ( *str != 0 );
}
//*********************************************************************************************************
//     END FILE - start kk
//*********************************************************************************************************

//uint8_t f_height=12,ascii_versatz=32,y=0,f_width=8,frame=0;
uint16_t curposx,curposy;
#define LCD_Write_Data_Only LCD_Send
#define  	SPI_CS_LOW 		LCD_CS(0)
#define  	SPI_CS_HIGH 	LCD_CS(1)

uint8_t *ptr_image=0, lcd_zeilen_versatz, ascii_versatz=32;
const uint8_t *ptr_font=f8x12;
uint8_t	f_width=8, f_height=12,vertikal_zeichnen=0, frame=0;
uint8_t frame_horz_versatz,frame_vert_versatz;
uint16_t curposx, curposy, Xpos,Ypos;
uint16_t backcolor=White,frontcolor=Black;


void selectfont(char abfr){
switch (abfr){
case (1):
ptr_font=f5x7;
f_width=5;
f_height=7;
vertikal_zeichnen=1;
frame=1;lcd_zeilen_versatz=9;
ascii_versatz=32,frame_vert_versatz=0,frame_horz_versatz=0;
break;
case (2):
ptr_font=f8x12;f_width=8; f_height=12;vertikal_zeichnen=0; frame=0;lcd_zeilen_versatz=0;
ascii_versatz=32,frame_vert_versatz=0,frame_horz_versatz=0;
break;
case (3):
ptr_font=f3x5;f_width=3; f_height=5;vertikal_zeichnen=0; frame=1;lcd_zeilen_versatz=0;
ascii_versatz=32,frame_vert_versatz=0,frame_horz_versatz=4;
break;
case (4):
ptr_font=z8x10;f_width=8; f_height=10;vertikal_zeichnen=0; frame=0;lcd_zeilen_versatz=0;
ascii_versatz=0,frame_vert_versatz=0,frame_horz_versatz=4;
break;
case (5):
ptr_font=z8x4;f_width=8; f_height=4;vertikal_zeichnen=0; frame=0;lcd_zeilen_versatz=0;
ascii_versatz=0,frame_vert_versatz=0,frame_horz_versatz=4;
break;
}
}


void lcd_goto(char Zeile,char Spalte){
curposx=(Spalte)*(f_width+frame);
curposy=(Zeile-1)*(f_height+2*frame)+lcd_zeilen_versatz;
//if(frame)curposy+=2;//-
}



void LCD_regionSTRING(
		uint16_t startx, uint16_t starty, char *str,
		uint16_t Color1, uint16_t Color2,uint8_t rand
		,uint8_t multiPixelx
		){
uint32_t index=0,ix=0,ih=0,xxx;
uint8_t in=0,xx,ilen,len,im,imh=0;

char x;
ilen=0;
/*for(ix=0;ix<30;ix++){
//	xx=str[ix];
	//xx=str+1;
	if (str[ix]=='\0')break;
	ilen++;
}*/

len=strlen(str);


for(ih=0;ih<f_height;ih++){
	for(imh=0;imh<multiPixelx;imh++){

/*
xxx=(f8x12[7+(*(str)-32)*12+ih]<<24)
		|(f8x12[7+(*(str)-32)*12+ih]<<16)
		|(f8x12[(*(str+1)-32)*12+7+ih]<<8)
		|(f8x12[(*(str+2)-32)*12+7+ih]);*/


//vertikal spiegeln
LCD_SetCursor(startx,starty+ih*multiPixelx+imh);
//LCD_SetCursor(startx,starty-ih);
//LCD_SetCursor(startx+len*f_width+rand*8,starty+ih);
curposx=startx;//+len*f_width+rand*8;
curposy=starty;

	LCD_WriteIndex(0x0022);
// 	SPI_CS_LOW;
	LCD_CS(0);
	LCD_RS(1);

//LCD_Write_Data_Start();
	//Rahmen links1
//	for( index = 0; index < 3; index++ ){LCD_Write_Data_Only(Color1);}
	//Rahmen links2
//	for( index = 3; index < 4; index++ ){LCD_Write_Data_Only(Color2);}
if(rand==1){
	LCD_Write_Data_Only(Black);LCD_WR(0);LCD_WR(1);
	LCD_Write_Data_Only(Black);LCD_WR(0);LCD_WR(1);
	LCD_Write_Data_Only(Black);LCD_WR(0);LCD_WR(1);
	LCD_Write_Data_Only(Red);LCD_WR(0);LCD_WR(1);
}
for (in=0;in<len;in++){

//RICHTUngswechsel
	ilen=in;
	//ilen=len-in-1;

	//xx	=(ptr_font[(*(str+in)-ascii_versatz)*f_height+7+ih]);
//	y=((*(str+in)-ascii_versatz)*10)+7+ih;
	xx	=(ptr_font[((*(str+ilen)-ascii_versatz)*f_height)+7+ih]);
	x=*(str+in);

	for(ix=0;ix<8;ix++){

		//Spiegeln
		for(im=0;im<multiPixelx;im++){
				if((xx & (0x80>>ix)))LCD_Write_Data_Only(Black);else LCD_Write_Data_Only(Color2);
		//		if((xx & (1<<ix)))LCD_Write_Data_Only(Color1);else LCD_Write_Data_Only(Color2);
				LCD_WR(0);
				LCD_WR(1);
		}
				//_delay_ms(1000);
	}


 //Rahmen
}
/* LCD_Write_Data_Only(Red);
				LCD_WR(0);
				LCD_WR(1);*/
 if(rand==1){
	LCD_Write_Data_Only(Red);LCD_WR(0);LCD_WR(1);
	LCD_Write_Data_Only(Black);LCD_WR(0);LCD_WR(1);
	LCD_Write_Data_Only(Black);LCD_WR(0);LCD_WR(1);
	LCD_Write_Data_Only(Black);LCD_WR(0);LCD_WR(1);

}
LCD_CS(1);
	}
}
curposx+=len*f_width*multiPixelx;
}

//checked
void lcd_write(char *str)
{
	if(frame)curposx++;
	LCD_regionSTRING(curposx,curposy,str,frontcolor,backcolor,0,1);
}

#define LCD_Write_Data_Start()//nothing


void gui_taste(uint16_t posx, uint16_t posy,uint8_t *text){//32x32
uint8_t i,rando[]={3,1,1,4,'\0'},randu[]={5,2,2,6,'\0'};
posy++;

selectfont(5);
LCD_regionSTRING(posx,posy,rando,Black,Red,0,1);

selectfont(2);
LCD_regionSTRING(posx,posy+4,"123",Magenta,Green,1,1);

LCD_regionSTRING(posx,posy+16,"456",Magenta,Green,1,1);

selectfont(5);
LCD_regionSTRING(posx,posy+28,randu,Black,Red,0,1);
selectfont(2);
}


void gui_regler(uint16_t posx, uint16_t posy,uint8_t *text){//32x32
uint8_t i,rando[]={3,1,1,1,1,1,1,1,1,4,'\0'},randu[]={5,2,2,2,2,2,2,2,2,6,'\0'};
posy++;
selectfont(5);
LCD_regionSTRING(posx,posy,rando,Black,Red,0,1);
selectfont(2);
LCD_regionSTRING(posx,posy+4,"-  VOL  +",Magenta,Green,1,1);
LCD_regionSTRING(posx,posy+16,"         ",Magenta,Green,1,1);
selectfont(5);
LCD_regionSTRING(posx,posy+28,randu,Black,Red,0,1);
selectfont(2);
}



